        section sprite
*
*
* Sprite movespr
*
*       Mode 4
*       +------|-------+
*       |aaaaaaaaaa    |
*       |awwwwwwwwa    |
*       |awwrrrrwwa    |
*       |awwrrrrwwaaaaa|
*       |awwrrwwwwwwwwa|
*       -awwwwwwwwrrwwa-
*       |aaaaawwrrrrwwa|
*       |    awwrrrrwwa|
*       |    awwwwwwwwa|
*       |    aaaaaaaaaa|
*       +------|-------+
*
        xdef    mes_move
mes_move
        dc.w    $0100,$0000
        dc.w    14,10,6,5
        dc.l    sc4_movespr-*
        dc.l    sm4_movespr-*
        dc.l    0
sc4_movespr
        dc.w    $0000,$0000
        dc.w    $7F7F,$8080
        dc.w    $617F,$8080
        dc.w    $617F,$8080
        dc.w    $677F,$F8F8
        dc.w    $7F7F,$98F8
        dc.w    $0607,$18F8
        dc.w    $0607,$18F8
        dc.w    $0707,$F8F8
        dc.w    $0000,$0000
sm4_movespr
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $0F0F,$FCFC
        dc.w    $0F0F,$FCFC
        dc.w    $0F0F,$FCFC
*
* Sprite zzz
*
*       Mode 4
*       +|---------------+
*       - wwwww          -
*       |waaaaaw         |
*       | wwwaw wwww     |
*       |  waw waaaaw    |
*       | wawww wwaw www |
*       |waaaaawwawwwaaaw|
*       | wwwwwwaaaawwaw |
*       |       wwwwwaaaw|
*       |            www |
*       +|---------------+
*
        xdef    mes_zzz
mes_zzz
        dc.w    $0100,$0000
        dc.w    16,9,0,0
        dc.l    sc4_zzz-*
        dc.l    sm4_zzz-*
        dc.l    0
sc4_zzz
        dc.w    $7C7C,$0000
        dc.w    $8282,$0000
        dc.w    $7575,$E0E0
        dc.w    $2A2A,$1010
        dc.w    $5D5D,$AEAE
        dc.w    $8383,$7171
        dc.w    $7E7E,$1A1A
        dc.w    $0101,$F1F1
        dc.w    $0000,$0E0E
        dc.w    $7C7C,$0000
        dc.w    $FEFE,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $3B3B,$F0F0
        dc.w    $7D7D,$EEEE
        dc.w    $FFFF,$FFFF
        dc.w    $7F7F,$FEFE
        dc.w    $0101,$FFFF
        dc.w    $0000,$0E0E
sm4_zzz
        dc.w    $7C7C,$0000
        dc.w    $FEFE,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $3B3B,$F0F0
        dc.w    $7D7D,$EEEE
        dc.w    $FFFF,$FFFF
        dc.w    $7F7F,$FEFE
        dc.w    $0101,$FFFF
        dc.w    $0000,$0E0E
        dc.w    $7C7C,$0000
        dc.w    $0000,$0000
        dc.w    $FEFE,$0000
        dc.w    $0000,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $0000,$0000
        dc.w    $3B3B,$F0F0
        dc.w    $0000,$0000
        dc.w    $7D7D,$EEEE
*
* Sprite CLOCK
*
*       Mode 4
*       +------------|------------+
*       |rrrrrrrrrrrrrrrrrrrrrrrrr|
*       |raraaaaaaaaaaaaaaaaaaarar|
*       |rarawwaawwwaaawaaawwwarar|
*       |raraawaaaawagawawawawarar|
*       -raraawaawwwaaawwwawwwarar-
*       |raraawaawaaagaaawawawarar|
*       |rarawwwawwwaaaaawawwwarar|
*       |raraaaaaaaaaaaaaaaaaaarar|
*       |rrrrrrrrrrrrrrrrrrrrrrrrr|
*       +------------|------------+
*
        xdef    mes_clock
mes_clock
        dc.w    $0100,$1900
        dc.w    25,9,12,4
        dc.l    sc4_uhr1-*
        dc.l    sm4_uhr1-*
        dc.l    sp4_uhr2-*
sc4_uhr1
        dc.w    $00FF,$00FF
        dc.w    $00FF,$0080
        dc.w    $00A0,$0000
        dc.w    $0002,$0080
        dc.w    $0CAC,$E2E2
        dc.w    $383A,$0080
        dc.w    $04A4,$2A22
        dc.w    $A8AA,$0080
        dc.w    $04A4,$E3E3
        dc.w    $B8BA,$0080
        dc.w    $04A4,$8880
        dc.w    $A8AA,$0080
        dc.w    $0EAE,$E0E0
        dc.w    $B8BA,$0080
        dc.w    $00A0,$0000
        dc.w    $0002,$0080
        dc.w    $00FF,$00FF
        dc.w    $00FF,$0080
sm4_uhr1
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$8080
*
sp4_uhr2
        dc.w    $0100,$3200
        dc.w    25,9,12,4
        dc.l    sc4_uhr2-*
        dc.l    sm4_uhr1-*
        dc.l    0
sc4_uhr2
        dc.w    $00FF,$00FF
        dc.w    $00FF,$0080
        dc.w    $00A0,$0000
        dc.w    $0002,$0080
        dc.w    $0CAC,$E2E2
        dc.w    $383A,$0080
        dc.w    $04A4,$2222
        dc.w    $A8AA,$0080
        dc.w    $04A4,$E3E3
        dc.w    $B8BA,$0080
        dc.w    $04A4,$8080
        dc.w    $A8AA,$0080
        dc.w    $0EAE,$E0E0
        dc.w    $B8BA,$0080
        dc.w    $00A0,$0000
        dc.w    $0002,$0080
        dc.w    $00FF,$00FF
        dc.w    $00FF,$0080
*
        end
