          section   main

          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_wman_menu_mac
          include   flp1_keys_colour
          include   flp1_qdos_pt
          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
*
*         Window definition
*
          window    pull                           ; start of definition
*
          size      236,48
          origin    40,10
          wattr     0,1,white,red
*
          sprite    0
*
          border    1,white
          iattr     black,red,0,0
          iattr     black,white,0,0
          iattr     green,black,0,0
*
          help      0
*
          size_opt  c
          size      236,48
          info      pull
          loos      pull
          dc.w      0
*
          s_end
*
*         Item definitions
*
          xlayout   pull
*
          layout    c,pull,pull,
*
          i_wlst    pull
*
          i_windw                                 ; Filename etc.
          size      224,10
          origin    6,20
          wattr     0,0,black,red
          olst      file
*
          i_end
*
          i_olst    file
*
          i_item                                  ; Info text
          size      224,10
          origin    0,0
          type      text
          ink       white
          csize     0,0
          text      name
*
          i_end
*
          l_ilst    pull
*
          l_item                                  ; ESC item
          size      30,12
          origin    4,4
          justify   0,0
          type      text
          selkey    esc
          text      esc
          item      0
          action    quit
*
          l_item                                  ; OVER item
          size      40,12
          origin    60,4
          justify   0,0
          type      text
          selkey    over
          text      over
          item      1
          action    0
*
          l_item                                  ; LOAD item
          size      40,12
          origin    104,4
          justify   0,0
          type      text
          selkey    load
          text      load
          item      2
          action    load
*
          l_item                                  ; MERGE item
          size      40,12
          origin    148,4
          justify   0,0
          type      text
          selkey    merge
          text      merge
          item      3
          action    merge
*
          l_item                                  ; SAVE item
          size      40,12
          origin    192,4
          justify   0,0
          type      text
          selkey    save
          text      save
          item      4
          action    save
*
          l_item                                  ; FILENAME item
          size      224,10
          origin    6,34
          justify   1,0
          type      text
          selkey    name
          dc.w      0
          item      5
          action    name
*
          i_end
*
          setwrk    c
*
*
*         Routine to pull-down 'FILE I/O' window
*
          xdef      pulldown
          xref      main_kill,wsav
          xref.s    mv_fname
*
dv_chid   equ       -4
dv_wmvec  equ       -8
dv_over   equ       -22
*
pull_tab  dc.l      wwc.pulldown
*
PULLDOWN  movem.l   d1/a0-a6,-(sp)                ; store registers
          move.l    ww_xorg(a4),d7                ; get window pos.
          move.l    pull_tab,d1                   ; get workspace
          moveq     #-1,d2                        ; for myself
          moveq     #mt.alchp,d0                  ; as a heap
          trap      #1
          tst.l     d0
          bne       main_kill                     ; error
          move.l    a0,a4                         ; working definition
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       wst_pull(a6),a1               ; status area
          clr.l     ws_litem(a1)                  ; clear items
          clr.w     ws_litem+4(a1)
          move.b    dv_over(a6),ws_litem+1(a1)    ; get OVERWRITE status
          lea       men_pull,a3                   ; window definition
          add.l     $4(a3),d7
          add.l     #$60014,d7
          move.l    dv_chid(a6),a0                ; channel ID
          moveq     #0,d1                         ; default size
          jsr       wm.setup(a2)                  ; set up window
          bne       main_kill                     ; error
          movem.l   a1/a2,-(sp)
          move.l    ww_plitm(a4),a1               ; set ptr to filename
          move.w    #wwl.elen*5,d1
          lea       mv_fname(a6),a2
          move.l    a2,wwl_pobj(a1,d1.w)
          movem.l   (sp)+,a1/a2
          move.l    d7,d1                         ; add main window
          jsr       wm.pulld(a2)                  ; pull down window
          bne       main_kill                     ; error
          jsr       wm.wdraw(a2)                  ; draw window contents
          bne.s     err_uns                       ; error
          move.l    a0,-(sp)
          move.l    8(sp),a0
          bsr       wsav
          move.l    (sp)+,a0
pull_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne.s     err_uns                       ; error
          btst      #pt..can,wsp_weve(a1)         ; ESC item set?
          beq.s     pull_rptr                     ; and again...
          bclr      #pt..can,wsp_weve(a1)         ; clear item status
err_uns   move.b    ws_litem+1(a1),dv_over(a6)    ; store OVERWRITE status
          move.b    d0,d7
          moveq     #-1,d1
          jsr       wm.unset(a2)                  ; unset definition
          bne       main_kill
          moveq     #io.close,d0                  ; and close window
          trap      #2
          move.l    a4,a0
          moveq     #mt.rechp,d0                  ; restore heap
          trap      #1
          movem.l   (sp)+,d1/a0-a6                ; restore registers
          rts
*
          end
