          section   main

          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_qdos_io
          include   flp1_qdos_pt
          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
          include   flp1_qdos3_inc
          include   flp1_macro_inc
          include   flp1_config_mac
*
          xref.s    wst_font,wst_button
          xref.s    mv_pappn,mv_pstat,mv_fname,mv_range
          xref.s    mv_font,mv_irang,mv_icurr
          xref.s    mcy_char,mcx_char
          xref.s    mcy_current,mcy_range
          xref.l    wwa.font,wwb.button
          xref      men_font,men_button
          xref      mes_dummys
          xref      sc4_pencil,sc4_cross,sc4_script
          xdef      main_kill,wsav,wsav0
          xdef      makecurr,makerang
          xdef      qtp_over
*
dv_chid   equ       -4
dv_wmvec  equ       -8
dv_wwork  equ       -12
dv_butpos equ       -16
dv_winpos equ       -20
dv_over   equ       -22
dv_spr1   equ       -46
dv_spr2   equ       -70
dv_end    equ       $50
*
*         Job header etc.
*
          job       {'fontEDITOR'}
          data      $2000
*
          lea       dv_end(a6,a4.l),a6            ; data area
          move.l    a6,a4
main_clr  clr.l     (a4)+                         ; clear all data
          cmp.l     a4,sp                         ; bottom of stack?
          bgt.s     main_clr
*
          move.b    qtp_over,dv_over(a6)          ; copy OVERWRITE mode
          move.l    qtp_xbut,d1                   ; preset button pos.
          add.l     men_button+4,d1
          move.l    d1,dv_butpos(a6)
          move.l    qtp_xorg,d1                   ; preset window pos.
          add.l     men_font+4,d1
          move.l    d1,dv_winpos(a6)
*
          lea       condef,a0                     ; console device
          moveq     #-1,d1                        ; for myself
          moveq     #2,d3                         ; exclusive
          qdosoc    io.open                       ; open it now
          tst.l     d0
          bne       main_kill                     ; ooops
          move.l    a0,dv_chid(a6)                ; keep channel ID
*
          moveq     #-1,d3
          qdosio    iop.pinf                      ; get pointer info
          tst.l     d0
          bne       noptr                         ; ooops
          cmpi.w    #'14',d1                      ; new pointer?
          bcs       oldptr                        ; ooops
          move.l    a1,d1                         ; WMAN vector?
          beq       nowman                        ; ooops
          move.l    d1,dv_wmvec(a6)               ; keep vector
          cmpi.w    #'08',2(a1)                   ; new WMAN?
          bcs       oldptr                        ; ooops
*
          qdosmt    mt.inf                        ; get SysVars
          btst      #3,sv_mcsta(a0)               ; test MODE
          beq.s     main_mode                     ; is MODE 4
          moveq     #0,d1
          moveq     #0,d2
          qdosmt    mt.dmode                      ; set MODE 4
*
main_mode bsr       setup
          bsr       winit
          move.b    qtp_set,d1
          beq       start_but
main_cont
          moveq     #$8,d2                        ; set priority
          moveq     #-1,d1
          qdosmt    mt.prior
*
          moveq     #1,d1
          move.w    d1,mcx_char(a6)               ; one section
          move.w    d2,mcx_char+wss_ssiz+2(a6)    ; with 8 columns
          move.w    d1,mcy_char(a6)               ; one section
          move.w    #9,mcy_char+wss_ssiz+2(a6)    ; with nine rows
          move.w    d1,mcy_current(a6)            ; one section
          move.w    d1,mcy_current+wss_ssiz+2(a6) ; with one row
          move.w    d1,mcy_range(a6)              ; one section
          move.w    d1,mcy_range+wss_ssiz+2(a6)   ; with one row
*
          lea       wst_font(a6),a1               ; status area
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       men_font,a3                   ; window definition
          move.l    dv_chid(a6),a0                ; channel ID
          moveq     #0,d1                         ; default size
          bsr       dsu_fset                      ; do first setup
          bne.s     main_kill                     ; ooops
*
          bsr       setappn                       ; init application window
          move.l    dv_winpos(a6),d1              ; pointer position
          jsr       wm.prpos(a2)                  ; position primary
          bne.s     main_kill                     ; ooops
*
          movem.l   a0-a3,-(sp)
          moveq     #0,d1
          bsr       makecurr
          bsr       makerang
          movem.l   (sp)+,a0-a3
          jsr       wm.wdraw(a2)                  ; draw window
          bne.s     main_kill                     ; ooops
          bsr.s     wsav
          bsr       msetspr                       ; define sprites
main_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne.s     main_kill                     ; ooops
          btst      #pt..zzzz,wsp_weve(a1)        ; SLEEP?
          bne       set_butt
          btst      #pt..can,wsp_weve(a1)         ; QUIT?
          beq.s     main_rptr
          bra.s     main_kill
*
noptr     lea       nptr,a1
          bra.s     kill_disp
nowman    lea       nwman,a1
          bra.s     kill_disp
oldptr    lea       optr,a1
*
kill_disp
          move.l    a1,-(sp)
          move.l    dv_chid(a6),a0                ; close main channel
          qdosoc    io.close
          qdosmt    mt.inf                        ; get SysVars
          move.l    sv_jbbas(a0),a0               ; first job
          move.l    (a0),a0
          lea       $68(a0),a0                    ; BV_BASE
          move.l    bv_comch(a0),a0               ; command chan ID
          move.l    (sp)+,a1
          vector    ut.mtext,a2                   ; print message
*
main_kill
          moveq     #0,d3
          moveq     #-1,d1
          qdosmt    mt.frjob                      ; kill this job
*
nowsav    rts
*
wsav      move.b    qtp_mod,d1
          beq.s     nowsav
wsav0     movem.l   a0/a1,-(sp)
          qdosmt    mt.inf
          move.l    sv_chbas(a0),a0
          move.w    2(sp),d1
          lsl.w     #2,d1
          move.l    (a0,d1.w),a0
wsav1     tst.b     ch_stat(a0)
          bne       wsav1
*
          move.l    (sp)+,a0
          move.l    (a4),a1
          move.w    ws_citem(a1),d4
          bmi.s     wsav3
          bset      #7,ws_citem(a1)
          move.w    wsp_swnr(a1),d2
          ble.s     wsav2
          subq.w    #4,ws_cihxs(a1)
          subq.w    #2,ws_cihys(a1)
          addq.w    #2,ws_cihxo(a1)
          addq.w    #1,ws_cihyo(a1)
wsav2     jsr       wm.drbdr(a2)
*
wsav3     suba.l    a1,a1
          moveq     #0,d1
          moveq     #-1,d3
          qdosio    iop.wsav
          tst.w     d4
          bmi.s     wsav5
          move.l    (a4),a1
          move.w    ws_cipap(a1),d1
          move.w    #7,ws_cipap(a1)
          jsr       wm.drbdr(a2)
          move.w    d1,ws_cipap(a1)
          tst.w     d2
          ble.s     wsav4
          addq.w    #4,ws_cihxs(a1)
          addq.w    #2,ws_cihys(a1)
          subq.w    #2,ws_cihxo(a1)
          subq.w    #1,ws_cihyo(a1)
wsav4     bclr      #7,ws_citem(a1)
wsav5     move.l    (sp)+,a1
          rts
*
*         Routine to change window to BUTTON
*
set_butt  move.l    ww_xorg(a4),d1                ; store window pos.
          add.l     men_font+4,d1
          move.l    d1,dv_winpos(a6)
          bsr.s     unset
start_but
          moveq     #1,d2                         ; set priority low
          moveq     #-1,d1
          qdosmt    mt.prior
*
          move.l    dv_chid(a6),a0                ; channel ID
          lea       wst_button(a6),a1             ; status area
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       men_button,a3                 ; window definition
          moveq     #0,d1                         ; default size
          bsr.s     bsu_fset                      ; do first setup
          bne       main_kill                     ; ooops
*
          move.l    dv_butpos(a6),d1              ; pointer pos.
          jsr       wm.prpos(a2)                  ; position primary
          bne       main_kill                     ; ooops
*
          bsr       bsetspr
          jsr       wm.wdraw(a2)                  ; draw window
          bne       main_kill                     ; ooops
          bsr       wsav0
*
butt_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne       main_kill                     ; ooops
          btst      #pt..zzzz,wsp_weve(a1)        ; SLEEP?
          bne.s     kill_butt
          btst      #pt..can,wsp_weve(a1)         ; QUIT?
          beq.s     butt_rptr
          bra       main_kill
*
*         Routine to return to FULL window
*
kill_butt move.l    ww_xorg(a4),d1                ; store this pos.
          add.l     men_button+4,d1
          move.l    d1,dv_butpos(a6)
          bsr.s     unset
          bra       main_cont
*
unset     move.l    dv_wmvec(a6),a2               ; unset main window
          moveq     #-1,d1
          jsr       wm.unset(a2)
          move.l    a4,a0                         ; kill heap
          qdosmt    mt.rechp
          rts
*
lsztab    dc.l      wwa.font
zzztab    dc.l      wwb.button
bsu_fset  movem.l   d1-d3/a0-a3,-(sp)             ; allocate heap
          move.l    zzztab,d1                     ; and do SETUP
          bra.s     dsu_doit
dsu_fset  movem.l   d1-d3/a0-a3,-(sp)             ; allocate heap
          move.l    lsztab,d1                     ; and do a SETUP
dsu_doit  moveq     #-1,d2
          qdosmt    mt.alchp
          move.l    a0,a4
          movem.l   (sp)+,d1-d3/a0-a3
          tst.l     d0
          bne.s     dsu_exit                      ; ooops
          move.l    a4,dv_wwork(a6)
          jsr       wm.setup(a2)
dsu_exit  rts

*
*         Routine to set up application sub-window
*
setappn   movem.l   a0-a3/d1-d3,-(sp)             ; store registers
          move.l    ww_pappl(a4),a1               ; application sub-windows
          move.l    (a1),a1                       ; first one
          lea       mv_pstat(a6),a0               ; room for status
          move.l    a0,wwa_mstt(a1)               ; store in working def.
          move.l    wwa_rowl(a1),a0               ; room for row list
          lea       mv_pappn(a6),a1               ; ptr to free space
          moveq     #0,d1                         ; first item number
          moveq     #8,d2                         ; number of item rows -1
setolop   moveq     #7,d3                         ; number of items -1
          move.l    a1,(a0)+                      ; store start pointer
setilop   clr.l     (a1)+
          clr.l     (a1)+
          move.w    d1,(a1)+
          addq.w    #1,d1
          clr.l     (a1)+
          dbf       d3,setilop
          move.l    a1,(a0)+                      ; store end pointer
          dbf       d2,setolop
          movem.l   (sp)+,a0-a3/d1-d3             ; restore registers
          rts
*
*         Routine to initialise filename
*
SETUP     movem.l   a0-a3,-(sp)                   ; store registers
          clr.w     mv_fname(a6)                  ; clear filename
          qdosmt    mt.inf                        ; get SysVars
          trap      #0
          move.l    sv_data(a0),d1                ; try to get DATAD$
          beq.s     fnend
          move.l    d1,a0                         ; valid address
          move.w    (a0)+,d1                      ; get length
          cmpi.w    #37,d1                        ; too long?
          bcs.s     fncopy
          moveq     #36,d1
fncopy    lea       mv_fname(a6),a1               ; get buffer address
          move.w    d1,(a1)+                      ; store length
          bra.s     fnlend
fnloop    move.b    (a0)+,(a1)+                   ; move string
fnlend    dbf       d1,fnloop
fnend     andi.w    #$dfff,sr
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts
*
*         Routine to init some items
*
WINIT     movem.l   a0-a3,-(sp)                   ; store registers
          moveq     #0,d1
          lea       qtp_rang,a1                   ; test range
          move.b    (a1),d1
          move.b    1(a1),d2
          cmp.b     d2,d1
          bcs.s     winit1
          beq.s     winit1
          exg       d1,d2
winit1    lea       mv_range(a6),a1
          move.b    d1,(a1)+
          move.b    d2,(a1)+
          move.b    d1,(a1)
          lea       mv_font(a6),a1                ; clear font area
          move.w    #575,d1
winit2    clr.l     (a1)+
          dbf       d1,winit2
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts
*
makecurr  lea       mv_icurr(a6),a1
          clr.w     (a1)
          move.b    mv_range+2(a6),d1
          bsr.s     makestr
          move.l    ww_pappl(a4),a3               ; get application window
          move.l    4(a3),a3
          move.l    wwa_rowl(a3),a3
          move.l    (a3),a3
          move.l    a1,wwm_pobj(a3)               ; store item address
          rts
*
makerang  lea       mv_irang(a6),a1
          clr.w     (a1)
          move.b    mv_range(a6),d1
          bsr.s     makestr
          move.w    (a1),d1                       ; get length
          move.b    #' ',2(a1,d1.w)               ; add ' to ' string
          move.b    #'t',3(a1,d1.w)
          move.b    #'o',4(a1,d1.w)
          move.b    #' ',5(a1,d1.w)
          addq.w    #4,(a1)                       ; increment length
          move.b    mv_range+1(a6),d1
          bsr.s     makestr
          move.l    ww_pappl(a4),a3               ; get application window
          move.l    8(a3),a3
          move.l    wwa_rowl(a3),a3
          move.l    (a3),a3
          move.l    a1,wwm_pobj(a3)               ; store item address
          rts
*
makestr   moveq     #0,d0
          move.w    (a1),d2                       ; get length
          lea       2(a1,d2.w),a2                 ; get string start
          moveq     #0,d2
          move.w    d1,d2                         ; copy parameter
          divu      #100,d2                       ; extract hundreds
          beq.s     makes1
          addq.w    #1,(a1)                       ; increment length
          move.b    d2,(a2)                       ; store result
          add.b     #$30,(a2)+                    ; make ASCII
          swap      d2                            ; correct parameter
          move.w    d2,d1
          moveq     #-1,d0
makes1    moveq     #0,d2
          move.w    d1,d2                         ; copy parameter
          divu      #10,d2                        ; extract tens
          bne.s     makes2
          tst.b     d0
          beq.s     makes3
makes2    addq.w    #1,(a1)                       ; increment length
          move.b    d2,(a2)                       ; store result
          add.b     #$30,(a2)+                    ; make ASCII
          swap      d2                            ; correct parameter
          move.w    d2,d1
makes3    addq.w    #1,(a1)                       ; increment length
          move.b    d1,(a2)
          add.b     #$30,(a2)+                    ; make ASCII
          moveq     #0,d0
          rts
*
*         Routine to define SPRITES
*
msetspr   movem.l   a0-a5,-(sp)                   ; store registers
          lea       dv_spr1(a6),a1                ; 1st sprite block
          lea       mes_dummys,a0                 ; size definitions
          move.l    ww_pappl(a4),a2               ; get subwindows
          lea       sc4_pencil,a4
          bsr.s     define
          lea       dv_spr2(a6),a1
          move.l    a1,a5
          lea       sc4_cross,a4
          bsr.s     define
          move.l    (a2),a3
          move.l    a5,wwa_pspr(a3)
          move.l    $10(sp),a4
          move.l    a5,ww_psprt(a4)
          movem.l   (sp)+,a0-a5
          rts
*
define    move.l    (a2)+,a3
          move.l    a1,wwa_pspr(a3)               ; pointer to sprite
define0   move.w    #$100,(a1)+
          clr.w     (a1)+
          move.l    (a0)+,(a1)+
          move.l    (a0)+,(a1)+
          move.w    (a4)+,d1
          sub.l     a1,a4
          move.l    a4,(a1)+
          add.w     d1,a4
          move.l    a4,(a1)+
          clr.l     (a1)
          rts
*
bsetspr   movem.l   a0-a4,-(sp)
          lea       dv_spr1(a6),a1
          lea       mes_dummys+$10,a0
          move.l    ww_plitm(a4),a3
          move.l    a1,wwl_pobj(a3)
          lea       sc4_script,a4
          bsr       define0
          movem.l   (sp)+,a0-a4
          rts
*
*
*         CONFIG Block
*
X         equ       wsi.slct
*
          mkcfhead  fontEDITOR,1.04
*
          mkcfitem  select,'B',qtp_set,,,{Start-up status}\
                    0,,{Window},1,,{Button}
          mkcfitem  select,'M',qtp_mod,,,{MODE guardian}\
                    0,,{On},1,,{Off}
          mkcfitem  word,'X',qtp_xorg,,,{X-origin of window},0,268
          mkcfitem  word,'Y',qtp_yorg,,,{Y-origin of window},0,129
          mkcfitem  word,'x',qtp_xbut,,,{X-origin of button},0,471
          mkcfitem  word,'y',qtp_ybut,,,{Y-origin of button},0,242
          mkcfitem  byte,'S',qtp_rang,,,{Character range 1},0,255
          mkcfitem  byte,'E',qtp_rang+1,,,{Character range 2},0,255
          mkcfitem  select,'O',qtp_over,,,{OVERWRITE status}\
                    0,,{On},1,,{Off}
*
          mkcfend
*
qtp_mod   dc.b      0,X
qtp_set   dc.b      X,0
qtp_ink   dc.b      7,0
qtp_xorg  dc.w      60
qtp_yorg  dc.w      30
qtp_xbut  dc.w      154
qtp_ybut  dc.w      5
qtp_rang  dc.b      32,127
qtp_over  dc.b      X,0
*
nptr      string    {'Pointer Interface not present',10}
nwman     string    {'Window Manager not present',10}
optr      string    {'Pointer Environment too old',10}
*
condef    string    {'CON_2x1a0x0'}
          dc.w      0
*
          end
