          section   main

          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_qdos_pt
          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
*
*         Action routines
*
          xdef      mea_quit,mea_zzz,mea_zret,mea_move
          xdef      mea_get,mea_put,mea_inve,mea_mirx,mea_miry
          xdef      mea_clear,mea_next,mea_back
          xdef      med_mdrw
          xdef      mea_pmhit,mea_cmhit,mea_rmhit
          xdef      mec_pctrl,mec_cctrl,mec_rctrl
          xdef      mem_smen
          xdef      mea_files,mea_name
          xdef      mea_load,mea_merge,mea_save
          xref.s    mv_range,mv_font,mv_fname
          xref      pulldown,makecurr,makerang
          xref      qtp_over,wsav,wsav0
*
dv_chid   equ       -4
dv_wwork  equ       -12
*
mea_quit  moveq     #pt..can,d4
          moveq     #0,d0
          rts
*
ldraw     move.l    a1,-(sp)
          move.w    wwl_item(a3),d4
          move.b    #1,ws_litem(a1,d4.w)
          moveq     #-1,d3
          jsr       wm.ldraw(a2)
          move.l    (sp)+,a1
          rts
*
mea_zret  cmpi.b    #2,wsp_kstr(a1)
          beq.s     mea_zzz
          cmpi.b    #$ed,wsp_kstr(a1)
          beq.s     mea_zzz
          cmpi.b    #8,wsp_kstr(a1)
          bne.s     mea_move
*
mea_zzz   bsr       ldraw
          clr.b     ws_litem(a1,d4.w)
          moveq     #pt..zzzz,d4
          moveq     #0,d0
          rts
*
mea_move  bset      #pt..wmov,wsp_weve(a1)
          jsr       wm.chwin(a2)
          bclr      #pt..wmov,wsp_weve(a1)
dac_exrd  move.w    wwl_item(a3),d2
          move.b    #wsi.mkav,ws_litem(a1,d2.w)
          moveq     #-1,d3
          jsr       wm.ldraw(a2)
          bclr      #wsi..chg,ws_litem(a1,d2.w)
          bsr       wsav0
          moveq     #0,d0
          moveq     #0,d4
          rts
*
mea_files bsr       pulldown
          tst.b     d7
          beq.s     redraw
meafiles  movem.l   a1/a3,-(sp)
          move.l    ww_pappl(a4),a1
          moveq     #2,d1
redloop   move.l    (a1)+,a3
          moveq     #0,d3
          jsr       wm.mdraw(a2)
          dbf       d1,redloop
          movem.l   (sp)+,a1/a3
redraw    bsr       ldraw
          bsr       wsav
          moveq     #0,d0
          moveq     #0,d4
          rts
*
mea_get   bsr       getchar
meaget    move.l    a3,-(sp)
          move.l    ww_pappl(a4),a3
          move.l    (a3),a3
          moveq     #0,d3
          jsr       wm.mdraw(a2)
          move.l    (sp)+,a3
          bra       redraw
*
mea_put   bsr       putchar
          bra       redraw
*
mea_clear movem.l   a0-a1,-(sp)
          bsr       getcsub
          moveq     #17,d1
clealoop  clr.l     (a1)+
          dbf       d1,clealoop
          movem.l   (sp)+,a0-a1
          bra       meaget
*
mea_inve  movem.l   a0-a1,-(sp)
          bsr       getcsub
          moveq     #71,d1
inveloop  eori.b    #$80,(a1)+
          dbf       d1,inveloop
          movem.l   (sp)+,a0-a1
          bra       meaget
*
mea_mirx  movem.l   a0-a1,-(sp)
          bsr       getcsub
          moveq     #8,d1
mirxolop  moveq     #3,d2
          moveq     #7,d3
mirxilop  move.b    (a1,d3.w),d0
          move.b    (a1),(a1,d3.w)
          move.b    d0,(a1)+
          subq.w    #2,d3
          dbf       d2,mirxilop
          addq.l    #4,a1
          dbf       d1,mirxolop
          movem.l   (sp)+,a0-a1
          bra       meaget
*
mea_miry  movem.l   a0-a1,-(sp)
          bsr       getcsub
          moveq     #3,d1
          moveq     #$40,d3
miryolop  moveq     #7,d2
miryilop  move.b    (a1,d3.w),d0
          move.b    (a1),(a1,d3.w)
          move.b    d0,(a1)+
          dbf       d2,miryilop
          sub.w     #$10,d3
          dbf       d1,miryolop
          movem.l   (sp)+,a0-a1
          bra       meaget
*
mea_name  move.l    a1,-(sp)
          moveq     #5,d1
          moveq     #0,d2
          jsr       wm.swlit(a2)
          lea       mv_fname(a6),a1
          jsr       wm.ename(a2)
          move.l    (sp)+,a1
          bsr       ldraw
          move.l    a0,-(sp)
          move.l    dv_chid(a6),a0
          bsr       wsav
          move.l    (sp)+,a0
          moveq     #0,d0
          moveq     #0,d4
          rts
*
nextsub   cmp.b     mv_range(a6),d1               ; too low ?
          bcc.s     next2
          move.b    mv_range+1(a6),d1             ; take last one
          bra.s     next3
next2     cmp.b     mv_range+1(a6),d1             ; too high ?
          bcs.s     next3
          beq.s     next3
          move.b    mv_range(a6),d1               ; take first one
next3     move.b    d1,mv_range+2(a6)             ; set current char
          moveq     #0,d1
          bra       makecurr
*
mea_next  movem.l   a0-a3,-(sp)                   ; store registers
          move.b    mv_range+2(a6),d1             ; current character
          addq.b    #1,d1
next1     bsr       nextsub
          bsr       getchar
          movem.l   (sp)+,a0-a3                   ; restore registers
          bra       meafiles
*
mea_back  movem.l   a0-a3,-(sp)                   ; store registers
          move.b    mv_range+2(a6),d1             ; current character
          subq.b    #1,d1
          bra       next1
*
io_error  bsr       alarm                         ; do error beep
io_end    movem.l   (sp)+,a0-a4                   ; restore registers
          bsr       ldraw
          moveq     #-1,d0                        ; set ERR.NC
          moveq     #3,d4                         ; ABORT event
          rts
*
mea_save  movem.l   a0-a4,-(sp)                   ; store registers
          lea       mv_fname(a6),a0               ; filename
          moveq     #2,d3                         ; new file
          move.b    ws_litem+1(a1),d1
          beq.s     save1
          moveq     #3,d3                         ; with overwrite
save1     moveq     #-1,d1                        ; for this job
          moveq     #io.open,d0                   ; open it...
          trap      #2
          tst.l     d0                            ; error ?
          bne       io_error
          moveq     #-1,d3                        ; timeout
          move.b    mv_range(a6),d1               ; first character
          moveq     #0,d2
          move.b    d1,d2
          moveq     #io.sbyte,d0                  ; send byte
          trap      #3
          tst.l     d0                            ; error ?
          bne       io_error
          move.b    mv_range+1(a6),d1             ; last character
          sub.b     d2,d1                         ; number of chars
          move.b    d1,d2
          moveq     #io.sbyte,d0                  ; send byte
          trap      #3
          tst.l     d0                            ; error ?
          bne       io_error
          addq.w    #1,d2
          mulu      #9,d2                         ; length to save
          moveq     #0,d1
          move.b    mv_range(a6),d1               ; calc start address
          mulu      #9,d1
          lea       mv_font(a6),a1                ; font start
          add.w     d1,a1                         ; plus offset
          moveq     #io.sstrg,d0                  ; send as a string
          trap      #3
          tst.l     d0                            ; error ?
          bne       io_error
          moveq     #io.close,d0                  ; close channel
          trap      #2
          bra       io_end
*
mea_merge moveq     #-1,d7
          bra.s     meaload
*
mea_load  moveq     #0,d7
meaload   movem.l   a0-a4,-(sp)                   ; store registers
          lea       mv_fname(a6),a0               ; filename
          moveq     #-1,d1                        ; channel for this job
          moveq     #1,d3                         ; old shared device
          moveq     #io.open,d0                   ; open it...
          trap      #2
          tst.l     d0                            ; error ?
          bne       io_error
          moveq     #-1,d3                        ; timeout
          moveq     #io.fbyte,d0                  ; get first byte
          trap      #3
          tst.l     d0
          bne       io_error                      ; error ?
          moveq     #0,d2
          move.b    d1,d2
          moveq     #io.fbyte,d0                  ; get second byte
          trap      #3
          tst.l     d0
          bne       io_error                      ; error ?
          move.b    d1,d0
          add.b     d2,d1                         ; calc last char
          bcs       io_error                      ; valid ?
          tst.b     d7
          beq.s     load2
          cmp.b     mv_range(a6),d2               ; check range
          bcc.s     load1
          move.b    d2,mv_range(a6)
load1     cmp.b     mv_range+1(a6),d1
          bcs.s     load3
          move.b    d1,mv_range+1(a6)
          bra.s     load3
load2     move.b    d2,mv_range(a6)               ; store range
          move.b    d2,mv_range+2(a6)
          move.b    d1,mv_range+1(a6)
load3     mulu      #9,d2                         ; calc load address
          lea       mv_font(a6),a1
          move.l    a1,a2
          add.w     d2,a1
          tst.b     d7
          bne.s     load4
          move.w    #575,d2
loadloop  clr.l     (a2)+                         ; clear font area
          dbf       d2,loadloop
load4     moveq     #0,d2
          move.b    d0,d2                         ; calc file length
          addq.w    #1,d2
          mulu      #9,d2
          moveq     #io.fstrg,d0                  ; load file
          trap      #3
          tst.l     d0
          bne       io_error                      ; error ?
          moveq     #io.close,d0                  ; close channel
          trap      #2
          move.l    dv_wwork(a6),a4               ; get main working def.
          moveq     #0,d1
          bsr       makecurr                      ; set new item strings
          bsr       makerang
          bsr       getchar
          bra       io_end
*
*         Actions for Application Sub-Windows
*
med_mdrw  jsr       wm.index(a2)
          bne.s     bomb
          jsr       wm.mdraw(a2)
bomb      rts
*
do_hit    jsr       wm.mhit(a2)
          cmpi.b    #3,d2
          bcc       bomb
          cmpi.b    #1,d2
          bcs       bomb
          movem.l   d0-d4,-(sp)
          bsr       wsav
          movem.l   (sp)+,d0-d4
          rts
*
mea_pmhit jsr       wm.msect(a2)
          tst.w     d0
          beq       do_hit
          bmi       do_hit
          cmpi.b    #$B,d4
          beq.s     do_scroll
do_pan
          btst      #8,d0
          beq.s     panleft
panright  btst      #10,d0
          bne       mea_next
          movem.l   a0-a3,-(sp)
          bsr       getcsub
          moveq     #8,d1
panrolop  move.b    7(a1),d3
          moveq     #6,d2
panrilop  move.b    (a1,d2.w),1(a1,d2.w)
          dbf       d2,panrilop
          move.b    d3,(a1)
          addq.l    #8,a1
          dbf       d1,panrolop
panend    movem.l   (sp),a0-a2
          move.l    ww_pappl(a4),a3
          move.l    (a3),a3
          moveq     #0,d3
          jsr       wm.mdraw(a2)
          movem.l   (sp)+,a0-a3
          bsr       wsav
          moveq     #0,d0
          moveq     #0,d4
          rts
*
panleft   btst      #10,d0
          bne       mea_back
          movem.l   a0-a3,-(sp)
          bsr       getcsub
          moveq     #8,d1
panlolop  move.b    (a1),d3
          moveq     #6,d2
          moveq     #0,d0
panlilop  move.b    1(a1,d0.w),(a1,d0.w)
          addq.w    #1,d0
          dbf       d2,panlilop
          move.b    d3,7(a1)
          addq.l    #8,a1
          dbf       d1,panlolop
          bra       panend
*
do_scroll movem.l   a0-a3,-(sp)
          btst      #10,d0
          bne.s     scrjump
          btst      #8,d0
          bne.s     scrdown
scrup     bsr       getcsub
          move.l    (a1)+,d2
          move.l    (a1)+,d3
          moveq     #15,d1
scruplop  move.l    (a1)+,-12(a1)
          dbf       d1,scruplop
          move.l    d3,-(a1)
          move.l    d2,-(a1)
          bra       panend
*
scrdown   bsr       getcsub
          moveq     #15,d1
          lea       72(a1),a1
          move.l    -(a1),d2
          move.l    -(a1),d3
scrdwlop  move.l    -(a1),8(a1)
          dbf       d1,scrdwlop
          move.l    d3,(a1)+
          move.l    d2,(a1)
          bra       panend
*
scrjump   move.b    mv_range+2(a6),d1
          btst      #8,d0
          beq.s     scrjup1
          subq.b    #8,d1
          bra.s     scrjup2
scrjup1   addq.b    #8,d1
scrjup2   bsr       cmhisub
          movem.l   (sp)+,a0-a3
          bsr       getchar
          bra       meafiles
*
mea_rmhit jsr       wm.msect(a2)
          cmpi.b    #$B,d4
          bne       mhit_rts
          movem.l   a0-a3,-(sp)
          move.l    (a4),a1
          move.w    wsp_xpos(a1),d7
          lea       mv_range(a6),a1
          move.b    (a1)+,d4
          move.b    (a1)+,d5
          move.b    (a1)+,d6
          moveq     #1,d3
          btst      #10,d0
          beq.s     rm_dohit
          moveq     #8,d3
rm_dohit  cmpi.w    #38,d7
          bcc.s     rm_right
          exg       d4,d5
rm_right  btst      #8,d0
          bne.s     rm_rdwn
rm_rup    add.b     d3,d5
          bra.s     rm_rght1
rm_rdwn   sub.b     d3,d5
rm_rght1  cmpi.w    #38,d7
          bcc.s     rm_rgh10
          cmp.b     d5,d4
          bcc.s     rm_rght2
          btst      #8,d0
          bne.s     rm_rgh00
          moveq     #0,d5
          bra.s     rm_rght2
rm_rgh00  move.b    d4,d5
          bra.s     rm_rght2
rm_rgh10  cmp.b     d4,d5
          bcc.s     rm_rght2
          btst      #8,d0
          bne.s     rm_rgh11
          move.b    d4,d5
          bra.s     rm_rght2
rm_rgh11  moveq     #-1,d5
rm_rght2  cmpi.w    #38,d7
          bcc.s     rm_rght3
          exg       d4,d5
rm_rght3  cmp.b     d6,d5
          bcc.s     rm_rght4
          move.b    d5,d6
          bra.s     rm_rght5
rm_rght4  cmp.b     d4,d6
          bcc.s     rm_rght5
          move.b    d4,d6
rm_rght5  move.b    d6,-(a1)
          move.b    d5,-(a1)
          move.b    d4,-(a1)
          moveq     #0,d1
          bsr       makerang
          bsr       makecurr
          movem.l   (sp),a0-a2
          move.l    ww_pappl(a4),a3
          lea       4(a3),a1
          moveq     #1,d1
rm_rght6  move.l    (a1)+,a3
          moveq     #0,d3
          jsr       wm.mdraw(a2)
          dbf       d1,rm_rght6
          bra       cctrl4
*
cmhisub   move.b    mv_range(a6),d2               ; too low ?
          cmp.b     d2,d1
          bcc.s     cmhi2
          sub.b     d1,d2
          move.b    mv_range+1(a6),d1             ; take last one
          sub.b     d2,d1
          bra.s     cmhi3
cmhi2     move.b    mv_range+1(a6),d2             ; too high ?
          cmp.b     d2,d1
          bcs.s     cmhi3
          beq.s     cmhi3
          sub.b     d2,d1
          add.b     mv_range(a6),d1               ; take first one
cmhi3     move.b    d1,mv_range+2(a6)             ; set current char
          moveq     #0,d1
          bra       makecurr
*
mea_cmhit jsr       wm.msect(a2)
          cmpi.b    #$B,d4
          bne       mhit_rts
          btst      #10,d0
          beq.s     cctrl0
          movem.l   a0-a3,-(sp)
          move.b    mv_range+2(a6),d1
          btst      #8,d0
          beq.s     cmhi0
          subq.b    #8,d1
          bra.s     cmhi1
cmhi0     addq.b    #8,d1
cmhi1     bsr       cmhisub
          bra.s     cctrl3
*
cctrl0    movem.l   a0-a3,-(sp)
          move.b    mv_range+2(a6),d1
          btst      #8,d0
          beq.s     cctrl1
          subq.b    #1,d1
          bra.s     cctrl2
cctrl1    addq.b    #1,d1
cctrl2    bsr       nextsub
cctrl3    movem.l   (sp),a0-a2
          move.l    ww_pappl(a4),a3
          move.l    4(a3),a3
          moveq     #0,d3
          jsr       wm.mdraw(a2)
cctrl4    bsr       wsav
          movem.l   (sp)+,a0-a3
mec_pctrl
mec_cctrl
mec_rctrl
mhit_rts  moveq     #0,d4
          moveq     #-1,d3
          moveq     #0,d0
          rts
*
mem_smen  jmp       wm.smenu(a2)
*
alarm     lea       beep,a3                       ; error beep
          moveq     #mt.ipcom,d0
          trap      #1
          rts
*
beep      dc.b      10,8,0,0,170,170,200,0,0,0,0,20,0,0,1,0
*
getcsub   lea       mv_font(a6),a0                ; font address
          moveq     #0,d1                         ; clear register
          move.b    mv_range+2(a6),d1             ; calc current char
          mulu      #9,d1
          add.w     d1,a0
          move.l    ww_pappl(a4),a1               ; get addr of item status
          move.l    (a1),a1
          move.l    wwa_mstt(a1),a1
          rts
*
getchar   movem.l   a0-a3,-(sp)                   ; store registers
          bsr       getcsub
          moveq     #8,d1                         ; row counter
getcolp   moveq     #7,d2                         ; column counter
          move.b    (a0)+,d0                      ; get font byte
getcilp   moveq     #0,d3                         ; preset data register
          lsl.b     #1,d0                         ; extract MS bit
          roxr.b    #1,d3                         ; insert in data reg.
          move.b    d3,(a1)+                      ; store status byte
          dbf       d2,getcilp
          dbf       d1,getcolp
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts
*
putchar   movem.l   a0-a3,-(sp)                   ; store registers
          bsr       getcsub
          moveq     #8,d1                         ; row counter
putcolp   moveq     #7,d2                         ; column counter
putcilp   move.b    (a1)+,d0                      ; get a status byte
          lsl.b     #1,d0                         ; extract MS bit
          roxl.b    #1,d3                         ; insert in font byte
          dbf       d2,putcilp
          move.b    d3,(a0)+                      ; store byte in font
          dbf       d1,putcolp
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts
*
          end
