        section sprite
*
*
* Sprite movespr
*
*       Mode 4
*       +------|-------+
*       |aaaaaaaaaa    |
*       |awwwwwwwwa    |
*       |awwrrrrwwa    |
*       |awwrrrrwwaaaaa|
*       |awwrrwwwwwwwwa|
*       -awwwwwwwwrrwwa-
*       |aaaaawwrrrrwwa|
*       |    awwrrrrwwa|
*       |    awwwwwwwwa|
*       |    aaaaaaaaaa|
*       +------|-------+
*
        xdef    mes_move
mes_move
        dc.w    $0100,$0000
        dc.w    14,10,6,5
        dc.l    sc4_movespr-*
        dc.l    sm4_movespr-*
        dc.l    0
sc4_movespr
        dc.w    $0000,$0000
        dc.w    $7F7F,$8080
        dc.w    $617F,$8080
        dc.w    $617F,$8080
        dc.w    $677F,$F8F8
        dc.w    $7F7F,$98F8
        dc.w    $0607,$18F8
        dc.w    $0607,$18F8
        dc.w    $0707,$F8F8
        dc.w    $0000,$0000
sm4_movespr
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $0F0F,$FCFC
        dc.w    $0F0F,$FCFC
        dc.w    $0F0F,$FCFC
*
* Sprite zzz
*
*       Mode 4
*       +|---------------+
*       - wwwww          -
*       |waaaaaw         |
*       | wwwaw wwww     |
*       |  waw waaaaw    |
*       | wawww wwaw www |
*       |waaaaawwawwwaaaw|
*       | wwwwwwaaaawwaw |
*       |       wwwwwaaaw|
*       |            www |
*       +|---------------+
*
        xdef    mes_zzz
mes_zzz
        dc.w    $0100,$0000
        dc.w    16,9,0,0
        dc.l    sc4_zzz-*
        dc.l    sm4_zzz-*
        dc.l    0
sc4_zzz
        dc.w    $7C7C,$0000
        dc.w    $8282,$0000
        dc.w    $7575,$E0E0
        dc.w    $2A2A,$1010
        dc.w    $5D5D,$AEAE
        dc.w    $8383,$7171
        dc.w    $7E7E,$1A1A
        dc.w    $0101,$F1F1
        dc.w    $0000,$0E0E
        dc.w    $7C7C,$0000
        dc.w    $FEFE,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $3B3B,$F0F0
        dc.w    $7D7D,$EEEE
        dc.w    $FFFF,$FFFF
        dc.w    $7F7F,$FEFE
        dc.w    $0101,$FFFF
        dc.w    $0000,$0E0E
sm4_zzz
        dc.w    $7C7C,$0000
        dc.w    $FEFE,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $3B3B,$F0F0
        dc.w    $7D7D,$EEEE
        dc.w    $FFFF,$FFFF
        dc.w    $7F7F,$FEFE
        dc.w    $0101,$FFFF
        dc.w    $0000,$0E0E
        dc.w    $7C7C,$0000
        dc.w    $0000,$0000
        dc.w    $FEFE,$0000
        dc.w    $0000,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $0000,$0000
        dc.w    $3B3B,$F0F0
        dc.w    $0000,$0000
        dc.w    $7D7D,$EEEE
*
* Sprite hand
*
*       Mode 4
*       +-|-------------------+
*       |       aaaaaaa       |
*       |      agggggggaaa    |
*       |       agggggggggaaa |
*       | aaaaaaaaaaagggggggga|
*       |aggggggggggggggggggga|
*       -aggggggggggggggggggga-
*       | aaaaaaaaaaggggggggga|
*       |      aggggggggggggga|
*       |      aggggggggggggga|
*       |       aaaaagggggggga|
*       |       agggggggggggga|
*       |       agggggggggggga|
*       |        aaaaaggggggga|
*       |        agggggggggaa |
*       |         aaaaaaaaa   |
*       +-|-------------------+
*
        xdef    sc4_hand,mes_dummys
mes_dummys
        dc.w    21,15,1,5
sc4_hand
        dc.w    sm4_hand-*-6
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0100,$FC00
        dc.w    $0000,$0000
        dc.w    $0000,$FF00
        dc.w    $8000,$0000
        dc.w    $0000,$0F00
        dc.w    $F000,$0000
        dc.w    $7F00,$FF00
        dc.w    $F000,$0000
        dc.w    $7F00,$FF00
        dc.w    $F000,$0000
        dc.w    $0000,$1F00
        dc.w    $F000,$0000
        dc.w    $0100,$FF00
        dc.w    $F000,$0000
        dc.w    $0100,$FF00
        dc.w    $F000,$0000
        dc.w    $0000,$0F00
        dc.w    $F000,$0000
        dc.w    $0000,$FF00
        dc.w    $F000,$0000
        dc.w    $0000,$FF00
        dc.w    $F000,$0000
        dc.w    $0000,$0700
        dc.w    $F000,$0000
        dc.w    $0000,$7F00
        dc.w    $C000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
sm4_hand
        dc.w    $0101,$FCFC
        dc.w    $0000,$0000
        dc.w    $0303,$FFFF
        dc.w    $8080,$0000
        dc.w    $0101,$FFFF
        dc.w    $F0F0,$0000
        dc.w    $7F7F,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $FFFF,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $FFFF,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $7F7F,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0303,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0303,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0101,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0101,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0101,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0000,$FFFF
        dc.w    $F8F8,$0000
        dc.w    $0000,$FFFF
        dc.w    $F0F0,$0000
        dc.w    $0000,$7F7F
        dc.w    $C0C0,$0000
*
        end
