          section   main

          include   flp1_wman_keys
          include   flp1_wman_wwork
          include   flp1_wman_wstatus
          include   flp1_qdos_io
          include   flp1_qdos_pt
          include   flp1_qdos1_inc
          include   flp1_qdos2_inc
          include   flp1_qdos3_inc
          include   flp1_macro_inc
          include   flp1_config_mac
*
          xref.s    wst_print
          xref.s    wst_button
          xref.l    wwa.print
          xref.l    wwb.button
          xref      men_print
          xref      men_button
          xref      sc4_printer,sp4_printer
          xref      sp4_crs0,sc4_crs0
          xref.s    mcy_f3,mcy_f4,mcy_f5,mcy_f7,mcy_f8
          xref.s    mv_port,mv_line,mv_char,mv_left,mv_right
          xdef      wsav,wsav0,main_kill
          xdef      qtp_crlf,qtp_sheet,qtp_nlq,qtp_init
          xref      ini_reset
*
dv_chid   equ       -4
dv_wmvec  equ       -8
dv_wwork  equ       -12
dv_butpos equ       -16
dv_winpos equ       -20
dv_spr1   equ       -44
dv_bigspr equ       -116
dv_port   equ       -120
dv_type   equ       -124
dv_end    equ       $80
*
*         Job header etc.
*
          job       {'printerPANEL'}
*
          lea       dv_end(a6),a6                 ; data area
          add.l     a4,a6
          move.l    a6,a4
main_clr  clr.l     (a4)+                         ; clear all data
          cmp.l     a4,sp                         ; bottom of stack?
          bgt.s     main_clr
*
          move.l    qtp_xbut,d1                   ; preset button pos.
          add.l     men_button+4,d1
          move.l    d1,dv_butpos(a6)
          move.l    qtp_xorg,d1                   ; preset window pos.
          add.l     men_print+4,d1
          move.l    d1,dv_winpos(a6)
*
          lea       condef,a0                     ; console device
          moveq     #-1,d1                        ; for myself
          moveq     #2,d3                         ; exclusive
          qdosoc    io.open                       ; open it now
          tst.l     d0
          bne       main_kill                     ; ooops
          move.l    a0,dv_chid(a6)                ; keep channel ID
*
          moveq     #-1,d3
          qdosio    iop.pinf                      ; get pointer info
          tst.l     d0
          bne       noptr                         ; ooops
          cmpi.w    #'14',d1                      ; new pointer?
          bcs       oldptr                        ; ooops
          move.l    a1,d1                         ; WMAN vector?
          beq       nowman                        ; ooops
          move.l    d1,dv_wmvec(a6)               ; keep vector
          cmpi.w    #'08',2(a1)                   ; new WMAN?
          bcs       oldptr                        ; ooops
*
          qdosmt    mt.inf                        ; get SysVars
          btst      #3,sv_mcsta(a0)               ; test MODE
          beq.s     main_mode                     ; is MODE 4
          moveq     #0,d1
          moveq     #0,d2
          qdosmt    mt.dmode                      ; set MODE 4
*
main_mode
          bsr       setport
          move.b    qtp_set,d1
          beq       start_but
main_cont
          moveq     #$10,d2                       ; set priority
          moveq     #-1,d1
          qdosmt    mt.prior
*
          lea       mv_port(a6),a0                ; try to open port
          moveq     #-1,d1
          moveq     #3,d3
          qdosoc    io.open
          tst.l     d0                            ; error?
          bne       start_but
          move.l    a0,dv_port(a6)                ; store port ID
*
          moveq     #1,d1
          move.w    d1,mcy_f3(a6)                 ; one section
          move.w    d1,mcy_f3+wss_ssiz+2(a6)      ; with 1 row
          move.w    d1,mcy_f4(a6)                 ; one section
          move.w    d1,mcy_f4+wss_ssiz+2(a6)      ; with 1 row
          move.w    d1,mcy_f5(a6)                 ; one section
          move.w    #3,mcy_f5+wss_ssiz+2(a6)      ; with 3 rows
          move.w    d1,mcy_f7(a6)                 ; one section
          move.w    d1,mcy_f7+wss_ssiz+2(a6)      ; with 1 row
          move.w    d1,mcy_f8(a6)                 ; one section
          move.w    d1,mcy_f8+wss_ssiz+2(a6)      ; with 1 row
*
          move.l    dv_chid(a6),a0                ; channel ID
          lea       wst_print(a6),a1              ; status area
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       men_print,a3                  ; window definition
          moveq     #0,d1                         ; default size
          bsr       dsu_fset                      ; do first setup
          bne.s     main_kill                     ; ooops
*
          move.l    dv_winpos(a6),d1              ; pointer position
          jsr       wm.prpos(a2)                  ; position primary
          bne.s     main_kill                     ; ooops
*
          bsr       setup
          bsr       ini_reset
          bne.s     main_kill
          bsr.s     wsav
          bsr       msetspr
main_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne.s     main_kill                     ; ooops
          btst      #pt..zzzz,wsp_weve(a1)        ; SLEEP?
          bne       set_butt
          btst      #pt..can,wsp_weve(a1)         ; QUIT?
          beq.s     main_rptr
          bra.s     main_kill
*
noptr     lea       nptr,a1
          bra.s     kill_disp
nowman    lea       nwman,a1
          bra.s     kill_disp
oldptr    lea       optr,a1
*
kill_disp
          move.l    a1,-(sp)
          move.l    dv_chid(a6),a0                ; close main channel
          qdosoc    io.close
          qdosmt    mt.inf                        ; get SysVars
          move.l    sv_jbbas(a0),a0               ; first job
          move.l    (a0),a0
          lea       $68(a0),a0                    ; BV_BASE
          move.l    bv_comch(a0),a0               ; command chan ID
          move.l    (sp)+,a1
          vector    ut.mtext,a2                   ; print message
*
main_kill
          moveq     #0,d3
          moveq     #-1,d1
          qdosmt    mt.frjob                      ; kill this job
*
nowsav    moveq     #0,d0
          moveq     #0,d4
          rts
*
wsav      move.b    qtp_mod,d0
          beq.s     nowsav
wsav0     movem.l   d1-d3/a0/a1,-(sp)
          qdosmt    mt.inf
          move.l    sv_chbas(a0),a0
          move.w    $e(sp),d1
          lsl.w     #2,d1
          move.l    (a0,d1.w),a0
wsav1     tst.b     ch_stat(a0)
          bne       wsav1
*
          move.l    $c(sp),a0
          move.l    (a4),a1
          move.w    ws_citem(a1),d4
          bmi.s     wsav3
          bset      #7,ws_citem(a1)
          move.w    wsp_swnr(a1),d2
          bmi.s     wsav2
          cmpi.w    #$100,d4
          bcs.s     wsav2
          subq.w    #4,ws_cihxs(a1)
          subq.w    #2,ws_cihys(a1)
          addq.w    #2,ws_cihxo(a1)
          addq.w    #1,ws_cihyo(a1)
wsav2     jsr       wm.drbdr(a2)
*
wsav3     suba.l    a1,a1
          moveq     #0,d1
          moveq     #-1,d3
          qdosio    iop.wsav
          tst.w     d4
          bmi.s     wsav5
          move.l    (a4),a1
          move.w    ws_cipap(a1),d1
          move.w    #7,ws_cipap(a1)
          jsr       wm.drbdr(a2)
          move.w    d1,ws_cipap(a1)
          tst.w     d2
          bmi.s     wsav4
          cmpi.w    #$100,d4
          bcs.s     wsav4
          addq.w    #4,ws_cihxs(a1)
          addq.w    #2,ws_cihys(a1)
          subq.w    #2,ws_cihxo(a1)
          subq.w    #1,ws_cihyo(a1)
wsav4     bclr      #7,ws_citem(a1)
wsav5     movem.l   (sp)+,d1-d3/a0/a1
          moveq     #0,d0
          moveq     #0,d4
          rts
*
*         Routine to change window to BUTTON
*
set_butt  move.l    ww_xorg(a4),d1                ; store window pos.
          add.l     men_print+4,d1
          move.l    d1,dv_winpos(a6)
          bsr.s     unset
          move.l    dv_port(a6),a0                ; close port channel
          qdosoc    io.close
start_but
          moveq     #1,d2                         ; set priority low
          moveq     #-1,d1
          qdosmt    mt.prior
*
          move.l    dv_chid(a6),a0                ; channel ID
          lea       wst_button(a6),a1             ; status area
          move.l    dv_wmvec(a6),a2               ; WMAN vector
          lea       men_button,a3                 ; window definition
          moveq     #0,d1                         ; default size
          bsr.s     bsu_fset                      ; do first setup
          bne       main_kill                     ; ooops
*
          move.l    dv_butpos(a6),d1              ; pointer pos.
          jsr       wm.prpos(a2)                  ; position primary
          bne       main_kill                     ; ooops
*
          bsr       bsetspr
          jsr       wm.wdraw(a2)                  ; draw window
          bne       main_kill                     ; ooops
          bsr       wsav0
*
butt_rptr
          jsr       wm.rptr(a2)                   ; read pointer
          bne       main_kill                     ; ooops
          btst      #pt..zzzz,wsp_weve(a1)        ; SLEEP?
          bne.s     kill_butt
          btst      #pt..can,wsp_weve(a1)         ; QUIT?
          beq.s     butt_rptr
          bra       main_kill
*
*         Routine to return to FULL window
*
kill_butt move.l    ww_xorg(a4),d1                ; store this pos.
          add.l     men_button+4,d1
          move.l    d1,dv_butpos(a6)
          bsr.s     unset
          bra       main_cont
*
unset     move.l    dv_wmvec(a6),a2               ; unset main window
          moveq     #-1,d1
          jsr       wm.unset(a2)
          move.l    a4,a0                         ; kill heap
          qdosmt    mt.rechp
          rts
*
lsztab    dc.l      wwa.print
zzztab    dc.l      wwb.button
bsu_fset  movem.l   d1-d3/a0-a3,-(sp)             ; allocate heap
          move.l    zzztab,d1                     ; and do SETUP
          bra.s     dsu_doit
dsu_fset  movem.l   d1-d3/a0-a3,-(sp)             ; allocate heap
          move.l    lsztab,d1                     ; and do a SETUP
dsu_doit  moveq     #-1,d2
          qdosmt    mt.alchp
          move.l    a0,a4
          movem.l   (sp)+,d1-d3/a0-a3
          tst.l     d0
          bne.s     dsu_exit                      ; ooops
          move.l    a4,dv_wwork(a6)
          jsr       wm.setup(a2)
dsu_exit  rts
*
*         Routines to define SPRITES
*
msetspr   movem.l   a0-a5,-(sp)                   ; store registers
          lea       dv_bigspr(a6),a1              ; 1st sprite block
          lea       sp4_crs0,a5                   ; size definitions
          lea       sc4_crs0,a3                   ; main definitions
          move.w    (a3)+,d1
          lea       (a3,d1.w),a4
          moveq     #3,d3
          moveq     #8,d2
sprlop1   move.l    a5,a0
          move.w    (a3)+,d1
          lea       (a3,d1.w),a2
          move.w    #$100,(a1)+
          move.b    d2,(a1)+
          clr.b     (a1)+
          move.l    (a0)+,(a1)+
          move.l    (a0)+,(a1)+
          sub.l     a1,a2
          move.l    a2,(a1)+
          move.l    a4,a2
          sub.l     a1,a2
          move.l    a2,(a1)+
          moveq     #4,d1
          move.l    d1,(a1)+
          addq.w    #8,d2
          dbf       d3,sprlop1
          clr.l     -(a1)
          add.b     #8,-18(a1)
          lea       dv_bigspr(a6),a1
          move.l    $10(sp),a4
          move.l    a1,ww_psprt(a4)
          move.w    ww_nappl(a4),d1
          move.l    ww_pappl(a4),a2
          bra.s     sprlop3
sprlop2   move.l    (a2)+,a0
          move.l    a1,wwa_pspr(a0)
sprlop3   dbf       d1,sprlop2
          movem.l   (sp)+,a0-a5
          rts
*
bsetspr   movem.l   a0-a2,-(sp)                   ; store registers
          lea       dv_spr1(a6),a1                ; 1st sprite block
          lea       sp4_printer,a0                ; size definitions
          move.l    ww_plitm(a4),a2               ; get items
          move.l    a1,wwl_pobj(a2)
          lea       sc4_printer,a2
          move.w    #$100,(a1)+
          clr.w     (a1)+
          move.l    (a0)+,(a1)+
          move.l    (a0)+,(a1)+
          move.w    (a2)+,d1
          sub.l     a1,a2
          move.l    a2,(a1)+
          add.w     d1,a2
          move.l    a2,(a1)+
          clr.l     (a1)
          movem.l   (sp)+,a0-a2
          rts
*
*         Routine to set default PORT name
*
setport   movem.l   a0-a3,-(sp)                   ; store registers
          clr.w     mv_port(a6)                   ; clear portname
          qdosmt    mt.inf                        ; get SysVars
          trap      #0
          move.l    sv_dest(a0),d1                ; try to get DESTD$
          beq.s     setpend
          move.l    d1,a0                         ; valid address
          move.w    (a0)+,d1                      ; get length
          cmpi.w    #13,d1                        ; too long?
          bcs.s     setp1
          moveq     #12,d1
setp1     lea       mv_port(a6),a1                ; get buffer address
          move.w    d1,(a1)+                      ; store length
          bra.s     setp3
setp2     move.b    (a0)+,(a1)+                   ; move string
setp3     dbf       d1,setp2
setpend   andi.w    #$dfff,sr
          move.l    qtp_typ,dv_type(a6)
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts
*
*         Main SETUP routine
*
setup     movem.l   a0-a3,-(sp)                   ; store registers
          moveq     #10,d1                        ; set ptr to portname
          lea       mv_port(a6),a1
          jsr       wm.stlob(a2)
          moveq     #14,d1                        ; set ptr to textline
          lea       mv_line(a6),a1
          jsr       wm.stlob(a2)
          moveq     #11,d1                        ; set ptr to spacing
          lea       mv_char(a6),a1
          jsr       wm.stlob(a2)
          move.l    ww_pappl(a4),a1               ; set ptr to margins
          move.l    $10(a1),a1
          move.l    wwa_rowl(a1),a1
          move.l    (a1),a1
          lea       mv_left(a6),a3
          move.l    a3,wwm_pobj(a1)
          add.w     #wwm.olen,a1
          lea       mv_right(a6),a3
          move.l    a3,wwm_pobj(a1)
          movem.l   (sp)+,a0-a3                   ; restore registers
          rts
*
*
*         CONFIG Block
*
X         equ       wsi.slct
*
          mkcfhead  printerPANEL,1.03
*
          mkcfitem  select,'B',qtp_set,,,{Start-up status}\
                    0,,{Window},1,,{Button}
          mkcfitem  select,'M',qtp_mod,,,{MODE guardian}\
                    0,,{On},1,,{Off}
          mkcfitem  word,'X',qtp_xorg,,,{X-origin of window},0,10
          mkcfitem  word,'Y',qtp_yorg,,,{Y-origin of window},0,95
          mkcfitem  word,'x',qtp_xbut,,,{X-origin of button},0,471
          mkcfitem  word,'y',qtp_ybut,,,{Y-origin of button},0,242
          mkcfitem  select,'T',qtp_typ,,,{Printer type}\
                    0,,{FX-800 compatible},1,,{Epson LQ},2,,{NEC P2200}
          mkcfitem  select,'S',qtp_sheet,,,{Sheet feeder installed}\
                    0,,{Yes},1,,{No}
          mkcfitem  select,'P',qtp_nlq,,,{Print mode}\
                    0,,{Draft},1,,{NLQ/LQ}
          mkcfitem  select,'I',qtp_init,,,{Initialize printer on start-up}\
                    0,,{Yes},1,,{No}
          mkcfitem  select,'L',qtp_crlf,,,{End-of-line code}\
                    0,,{CR+LF},1,,{CR},2,,{none}
*
          mkcfend
*
qtp_mod   dc.b      0,X
qtp_set   dc.b      X,0
qtp_xorg  dc.w      8
qtp_yorg  dc.w      30
qtp_xbut  dc.w      202
qtp_ybut  dc.w      5
qtp_typ   dc.b      0,0,X,0
qtp_crlf  dc.b      X,0,0,0
qtp_sheet dc.b      0,X
qtp_nlq   dc.b      0,X
qtp_init  dc.b      X,0
*
nptr      string    {'Pointer Interface not present',10}
nwman     string    {'Window Manager not present',10}
optr      string    {'Pointer Environment too old',10}
*
condef    string    {'CON_2x1a0x0'}
          dc.w      0
*
          end
