        section sprite
*
*
* Sprite movespr
*
*       Mode 4
*       +------|-------+
*       |aaaaaaaaaa    |
*       |awwwwwwwwa    |
*       |awwrrrrwwa    |
*       |awwrrrrwwaaaaa|
*       |awwrrwwwwwwwwa|
*       -awwwwwwwwrrwwa-
*       |aaaaawwrrrrwwa|
*       |    awwrrrrwwa|
*       |    awwwwwwwwa|
*       |    aaaaaaaaaa|
*       +------|-------+
*
        xdef    mes_move
mes_move
        dc.w    $0100,$0000
        dc.w    14,10,6,5
        dc.l    sc4_movespr-*
        dc.l    sm4_movespr-*
        dc.l    0
sc4_movespr
        dc.w    $0000,$0000
        dc.w    $7F7F,$8080
        dc.w    $617F,$8080
        dc.w    $617F,$8080
        dc.w    $677F,$F8F8
        dc.w    $7F7F,$98F8
        dc.w    $0607,$18F8
        dc.w    $0607,$18F8
        dc.w    $0707,$F8F8
        dc.w    $0000,$0000
sm4_movespr
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$C0C0
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $FFFF,$FCFC
        dc.w    $0F0F,$FCFC
        dc.w    $0F0F,$FCFC
        dc.w    $0F0F,$FCFC
*
* Sprite zzz
*
*       Mode 4
*       +|---------------+
*       - wwwww          -
*       |waaaaaw         |
*       | wwwaw wwww     |
*       |  waw waaaaw    |
*       | wawww wwaw www |
*       |waaaaawwawwwaaaw|
*       | wwwwwwaaaawwaw |
*       |       wwwwwaaaw|
*       |            www |
*       +|---------------+
*
        xdef    mes_zzz
mes_zzz
        dc.w    $0100,$0000
        dc.w    16,9,0,0
        dc.l    sc4_zzz-*
        dc.l    sm4_zzz-*
        dc.l    0
sc4_zzz
        dc.w    $7C7C,$0000
        dc.w    $8282,$0000
        dc.w    $7575,$E0E0
        dc.w    $2A2A,$1010
        dc.w    $5D5D,$AEAE
        dc.w    $8383,$7171
        dc.w    $7E7E,$1A1A
        dc.w    $0101,$F1F1
        dc.w    $0000,$0E0E
        dc.w    $7C7C,$0000
        dc.w    $FEFE,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $3B3B,$F0F0
        dc.w    $7D7D,$EEEE
        dc.w    $FFFF,$FFFF
        dc.w    $7F7F,$FEFE
        dc.w    $0101,$FFFF
        dc.w    $0000,$0E0E
sm4_zzz
        dc.w    $7C7C,$0000
        dc.w    $FEFE,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $3B3B,$F0F0
        dc.w    $7D7D,$EEEE
        dc.w    $FFFF,$FFFF
        dc.w    $7F7F,$FEFE
        dc.w    $0101,$FFFF
        dc.w    $0000,$0E0E
        dc.w    $7C7C,$0000
        dc.w    $0000,$0000
        dc.w    $FEFE,$0000
        dc.w    $0000,$0000
        dc.w    $7D7D,$E0E0
        dc.w    $0000,$0000
        dc.w    $3B3B,$F0F0
        dc.w    $0000,$0000
        dc.w    $7D7D,$EEEE
*
* Sprite printer
*
*       Mode 4
*       +|-----------------------------+
*       -rrrrrrrrrrrrrrrrrrrrrrrrrrrrr -
*       |rgrrrrrrrrrrrrrrrrrrrrrrrrrgr |
*       |rrr   rrrr rrrrrr rrrrrrrrrrr |
*       |rrr r rrrrrrrrrr   rrrrrrrrrr |
*       |rgr   r  r r   rr rr   r  rgr |
*       |rrr rrr rr r r rr rr r r rrrr |
*       |rrr rrr rr r r rr rr  rr rrrr |
*       |rgr rrr rr r r rr  r   r rrgr |
*       | rrrrrrrrrrrrrrrrrrrrrrrrrrrrr|
*       +|-----------------------------+
*
        xdef    sc4_printer,sp4_printer
sp4_printer
        dc.w    30,9,0,0
sc4_printer
        dc.w    sm4_printer-*-6
        dc.w    $00FF,$00FF
        dc.w    $00FF,$00F8
        dc.w    $40BF,$00FF
        dc.w    $00FF,$10E8
        dc.w    $00E3,$00DF
        dc.w    $00BF,$00F8
        dc.w    $00EB,$00FF
        dc.w    $001F,$00F8
        dc.w    $40A2,$0051
        dc.w    $00B1,$1028
        dc.w    $00EE,$00D5
        dc.w    $00B5,$0078
        dc.w    $00EE,$00D5
        dc.w    $00B3,$0078
        dc.w    $40AE,$00D5
        dc.w    $0091,$1068
        dc.w    $007F,$00FF
        dc.w    $00FF,$00FC
sm4_printer
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$F8F8
        dc.w    $FFFF,$FFFF
        dc.w    $FFFF,$F8F8
        dc.w    $E3E3,$DFDF
        dc.w    $BFBF,$F8F8
        dc.w    $EBEB,$FFFF
        dc.w    $1F1F,$F8F8
        dc.w    $E2E2,$5151
        dc.w    $B1B1,$3838
        dc.w    $EEEE,$D5D5
        dc.w    $B5B5,$7878
        dc.w    $EEEE,$D5D5
        dc.w    $B3B3,$7878
        dc.w    $EEEE,$D5D5
        dc.w    $9191,$7878
        dc.w    $7F7F,$FFFF
        dc.w    $FFFF,$FCFC
*
* Sprite cross
*
*       Mode 4
*       +-|-----------------+
*       -        a a        -
*       |       agwga       |
*       |       agwga       |
*       |       agaga       |
*       |       agaga       |
*       | aaaaaaagagaaaaaaa |
*       |agggggggaaaggggggga|
*       | awwaaaaaaaaaaawwa |
*       |agggggggaaaggggggga|
*       | aaaaaaagagaaaaaaa |
*       |       agaga       |
*       |       agaga       |
*       |       agwga       |
*       |       agwga       |
*       |        a a        |
*       +-|-----------------+
*
        xdef    sp4_crs0,sc4_crs0
sp4_crs0
        dc.w    19,15,9,7
sc4_crs0
        dc.w    sm4_crs1-*-2
        dc.w    sc4_crs1-*-2
        dc.w    sc4_crs2-*-2
        dc.w    sc4_crs3-*-2
        dc.w    sc4_crs4-*-2
sc4_crs1
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $7F00,$1F00
        dc.w    $C000,$0000
        dc.w    $3030,$0101
        dc.w    $8080,$0000
        dc.w    $7F00,$1F00
        dc.w    $C000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
sm4_crs1
        dc.w    $0000,$A0A0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $7F7F,$FFFF
        dc.w    $C0C0,$0000
        dc.w    $FFFF,$FFFF
        dc.w    $E0E0,$0000
        dc.w    $7F7F,$FFFF
        dc.w    $C0C0,$0000
        dc.w    $FFFF,$FFFF
        dc.w    $E0E0,$0000
        dc.w    $7F7F,$FFFF
        dc.w    $C0C0,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0101,$F0F0
        dc.w    $0000,$0000
        dc.w    $0000,$A0A0
        dc.w    $0000,$0000
*
sc4_crs2
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $7F00,$1F00
        dc.w    $C000,$0000
        dc.w    $0C0C,$0606
        dc.w    $0000,$0000
        dc.w    $7F00,$1F00
        dc.w    $C000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
*
sc4_crs3
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $7F00,$5F40
        dc.w    $C000,$0000
        dc.w    $0303,$1818
        dc.w    $0000,$0000
        dc.w    $7F00,$5F40
        dc.w    $C000,$0000
        dc.w    $0000,$E040
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
*
sc4_crs4
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $7F00,$5F40
        dc.w    $C000,$0000
        dc.w    $0000,$E0E0
        dc.w    $0000,$0000
        dc.w    $7F00,$5F40
        dc.w    $C000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$A000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
        dc.w    $0000,$0000
*
        end
