          section   main

          include   flp1_wman_text_mac
          include   flp1_keys_k
          include   flp1_macro_inc
*
*         String definitions
*
          mkxstr    quit,k.cancel,{QUIT}
          mkxstr    printer,,{printer}
          mkxstr    panel,,{PANEL}
          mkxstr    reset,'@',{RESET}
          mkxstr    fx80,,{FX-800}
          mkxstr    epslq,,{Epson LQ}
          mkxstr    neclq,,{NEC LQ}
          mkxstr    f2,,{F2 Main Controls}
          mkxstr    quiet,'Q',{Low Noise}
          mkxstr    line,'L',{Line Feed}
          mkxstr    form,'F',{Form Feed}
          mkxstr    skip,'S',{Skip Perforation}
          mkxstr    fed1,'1',{Sheet Feeder #1}
          mkxstr    fed2,'2',{Sheet Feeder #2}
          mkxstr    f3,,{F3 Justification}
          mkxstr    f4,,{F4 Size}
          mkxstr    f5,,{F5 Features}
          mkxstr    emph,,{Emphasized}
          mkxstr    double,,{Double Strike}
          mkxstr    cond,,{Condensed}
          mkxstr    low,,{Subscript}
          mkxstr    high,,{Superscript}
          mkxstr    under,,{Underline}
          mkxstr    ital,,{Italics}
          mkxstr    dwid,,{Double Width}
          mkxstr    twid,,{Triple Width}
          mkxstr    dhei,,{Double Height}
          mkxstr    outl,,{Outline}
          mkxstr    shad,,{Shadow}
          mkxstr    f6,,{F6 Margins}
          mkxstr    left,,{Left:}
          mkxstr    right,,{Right:}
          mkxstr    f7,,{F7 Line Spacing}
          mkxstr    cr,'1',{CR}
          mkxstr    crlf,'2',{CR+LF}
          mkxstr    none,'0',{none}
          mkxstr    f8,,{F8 Typeface}
          mkxstr    port,'P',{Port:}
          mkxstr    char,'S',{Spacing:}
          mkxstr    revers,'X',{Reverse}
          mkxstr    normal,'Z',{Normal}
          mktext    tabs,{....:....1....:....2....:....3....:....4}\
                         {....:....5....:....6....:....7....:....8.}
*
          xdef      size,justy,feeds
*
size      dc.w      3
          dc.w      pica-size,elite-size
          dc.w      micro-size,prop-size
pica      string    {'Pica'}
elite     string    {'Elite'}
micro     string    {'Microscript'}
prop      string    {'Proportional'}
*
justy     dc.w      3
          dc.w      jleft-justy,jcentre-justy
          dc.w      jright-justy,jblock-justy
jleft     string    {'Left'}
jcentre   string    {'Centre'}
jright    string    {'Right'}
jblock    string    {'Block'}
*
feeds     dc.w      6
          dc.w      lf1-feeds,lf2-feeds
          dc.w      lf3-feeds,lf4-feeds
          dc.w      lf5-feeds,lf6-feeds
          dc.w      lf7-feeds
lf1       string    {'1/9 inch'}
lf2       string    {'1/8 inch'}
lf3       string    {'1/6 inch'}
lf4       string    {'1/4 inch'}
lf5       string    {'1/3 inch'}
lf6       string    {'1/2 inch'}
lf7       string    {'1/1 inch'}
*
          xdef      fxsets,lqsets,necsets
*
fxsets    dc.w      1
          dc.w      fx1-fxsets,fx2-fxsets
fx1       string    {'Draft'}
fx2       string    {'NLQ'}
*
lqsets    dc.w      9
          dc.w      fx1-lqsets,lq2-lqsets
          dc.w      lq3-lqsets,lq4-lqsets
          dc.w      lq5-lqsets,lq6-lqsets
          dc.w      lq7-lqsets,lq8-lqsets
          dc.w      lq9-lqsets,lq10-lqsets
lq2       string    {'Roman'}
lq3       string    {'Sans Serif'}
lq4       string    {'Courier'}
lq5       string    {'Prestige'}
lq6       string    {'Script'}
lq7       string    {'OCR-B'}
lq8       string    {'OCR-A'}
lq9       string    {'Orator'}
lq10      string    {'Orator S'}
*
necsets   dc.w      5
          dc.w      fx1-necsets,lq4-necsets
          dc.w      nec3-necsets,lq7-necsets
          dc.w      nec5-necsets,nec6-necsets
nec3      string    {'Super Focus'}
nec5      string    {'ITC Souvenir'}
nec6      string    {' Slot '}
*
          mkselk    move,k.move
*
          end
